<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="50%">
      <v-card>
        <v-card-title>
          <span v-text="title" />
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="4">
                <v-checkbox
                    v-model="isParentOnly"
                    label="Parent Only"
                    class="shrink mr-2 mt-0"
                    :disabled="isComponentOnly || isChildOnly"
                    @change="doChangeParentOnly"
                />
              </v-col>
              <v-col cols="4">
                <v-checkbox
                    v-model="isChildOnly"
                    label="Child Only"
                    class="shrink mr-2 mt-0"
                    :disabled="isComponentOnly || isParentOnly"
                    @change="setResetError"
                />
              </v-col>
              <v-col cols="4">
                <v-checkbox
                    v-model="isComponentOnly"
                    label="Component Only"
                    class="shrink mr-2 mt-0"
                    :disabled="isParentOnly || isChildOnly"
                    @change="doChangeComponentOnly"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-select
                    v-model="menu.menu_type"
                    :items="clients"
                    label="Menu Type*"
                    :disabled="statusProgress"
                    :error-messages="error_payload.menu_type"
                    @change="setResetError"
                    @blur="setResetError"
                />
              </v-col>
              <v-col cols="4">
                <v-select
                    v-model="menu.parent_id"
                    :items="menuParents"
                    item-text="name"
                    item-value="id"
                    label="Menu Parent*"
                    :disabled="isParentOnly  || isComponentOnly && !isChildOnly"
                    :error-messages="error_payload.parent_id"
                    @change="setResetError"
                    @blur="setResetError"
                />
              </v-col>
              <v-col cols="4">
                <v-select
                    v-model="menu.form_app"
                    :items="form_apps"
                    item-text="name"
                    item-value="pk"
                    label="Form/Component*"
                    :disabled="isParentOnly || !isChildOnly && !isComponentOnly"
                    :error-messages="error_payload.form_app"
                    @change="setResetError"
                    @blur="setResetError"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4" v-if="isEdit">
                <v-text-field label="ID*" v-model="menu.id" required v-if="isEdit"  :error-messages="error_payload.id" @input="setResetError" @blur="setResetError" />
              </v-col>
              <v-col cols="4">
                <v-text-field label="Name*" v-model="menu.name" :disabled="statusProgress" required :error-messages="error_payload.name" @input="setResetError" @blur="setResetError" />
              </v-col>
              <v-col cols="4">
                <v-text-field label="Sequence*" v-model="menu.seq" type="number" :disabled="statusProgress" required :error-messages="error_payload.seq" @input="setResetError" @blur="setResetError" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="6">
                <v-text-field label="Path*" v-model="menu.path" :disabled="isParentOnly || !isChildOnly && !isComponentOnly" required :error-messages="error_payload.path" @input="setResetError" @blur="setResetError" />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Path Parameter*" v-model="menu.path_parameter" :disabled="isParentOnly || !isChildOnly && !isComponentOnly" required @input="setResetError" @blur="setResetError" />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
          <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
          <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
        </v-card-actions>
      </v-card>
      <DlgMsg ref="dlgMsg" />
      <Loading ref="loading" :dlg-loading="statusProgress" />
    </v-dialog>
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import menuServices from "../service/MenuService";
import {checkError400, checkError404, loadMenu} from "../utils/util";
import formAppService from "../service/FormAppService";

export default {
  name: "MenuForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      clients: [],
      form_apps: [],
      menuParents: [],
      menu: {
        id: null,
        menu_type: null,
        name: null,
        parent_id: null,
        path: null,
        path_parameter: null,
        form_app: {
          id: null,
          form_type: null,
        },
        seq: null,
      },
      error_payload: {
        id: [],
        menu_type: [],
        parent_id: [],
        form_app: [],
        name: [],
        path: [],
        seq: [],
      },
      title: null,
      dialog: false,
      isEdit: false,
      isParentOnly: false,
      isChildOnly: false,
      isComponentOnly: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    async doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      this.statusProgress = true
      this.doLoadClientId()
      this.doLoadMenuParents()
      this.doLoadFormApp()
      this.statusProgress = false
    },
    doEdit(dataPk, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.statusProgress = true
      this.doLoadClientId()
      this.doLoadMenuParents()
      this.doLoadFormApp()
      this.retrieveMenu(dataPk)
    },
    doReset() {
      if (!this.isEdit)
        this.menu.id = '0'
      this.menu.menu_type = null
      this.menu.name = null
      this.menu.parent_id = null
      this.menu.path = null
      this.menu.path_parameter = null
      this.menu.form_app = null
      this.menu.seq = null

      this.isParentOnly = false
      this.isChildOnly = false
      this.isComponentOnly = false

      this.setResetError()
    },
    setResetError() {
      this.error_payload.id = []
      this.error_payload.menu_type = []
      this.error_payload.name = []
      this.error_payload.parent_id = []
      this.error_payload.path = []
      this.error_payload.path_parameter = []
      this.error_payload.form_app = []
      this.error_payload.seq = []
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let menu = this.menu
      let data = {
        id: menu.id,
        menu_type: menu.menu_type,
        seq: menu.seq,
      }
      if ((this.isComponentOnly || this.isChildOnly) && !this.isParentOnly) {
        data.name = menu.name
        data.path = menu.path
        data.path_parameter = menu.path_parameter
        data.form_app = menu.form_app
      }
      if ((this.isParentOnly || this.isChildOnly) && !this.isComponentOnly) {
        data.parent_id = menu.parent_id
      }

      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data)
      }
      this.statusProgress = false
    },
    async doSave(data) {
      await menuServices.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
    },
    doUpdate(data) {
      menuServices.update(data)
          .then(async res => {
            let isChangeComponen = false
            let {data, status} = res.data
            if (status === "SUCCESS") {
              await this.$parent.doRefresh()
              await window._VMA.$emit('REFRESH_TOKEN')
              let route = await loadMenu(data)
              if (route != null && data.form_app != null) {
                if (await this.$refs.dlgMsg.confirm(`${data.message} \nApakah Ingin Refresh Halaman Untuk Memuat Component Baru?`)) {
                  isChangeComponen = true
                  this.$router.go(0)
                }
              }
            }
            if (!isChangeComponen) {
              this.dialog = false
              this.$refs.dlgMsg.doOpenMsg(res.data.message)
              this.statusProgress = false
            }
          })
          .catch(ex => {
            console.log(ex)
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
    },
    async retrieveMenu(dataPk) {
      this.statusProgress = true
      await menuServices.getByIdAndType(dataPk.id, dataPk.menu_type)
          .then(res => {
            let {status, data} = res.data
            if (status === 'SUCCESS') {
              this.menu = data
              if (this.menu.parent_id == null && !this.menu.form_app) {
                this.isParentOnly = true
                this.isChildOnly = false
                this.isComponentOnly = false
              } else if (this.menu.parent_id == null && this.menu.form_app) {
                this.menu.form_app.pk = {
                  id: this.menu.form_app.id,
                  form_type: this.menu.form_app.form_type,
                }
                this.isParentOnly = false
                this.isChildOnly = false
                this.isComponentOnly = true
              } else {
                this.menu.form_app.pk = {
                  id: this.menu.form_app.id,
                  form_type: this.menu.form_app.form_type,
                }
                this.isParentOnly = false
                this.isChildOnly = true
                this.isComponentOnly = false
              }
            } else {
              this.$refs.dlgMsg.doOpenMsg(data.message)
            }
          }).catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
      })
      this.statusProgress = false
    },
    validation() {
      if (!this.isParentOnly && !this.isChildOnly && !this.isComponentOnly) {
        this.$refs.dlgMsg.doOpenMsg('Tipe Menu Harus Dipilih')
        return false
      } else {
        if (this.menu.parent_id == null && !this.isParentOnly) {
          this.$refs.dlgMsg.doOpenMsg('Menu Parent Harus Dipilih')
          return false
        }
      }
      return true
    },
    async doLoadMenuParents() {
      await menuServices.getByParent().then(resp => {
        let status = resp.data.status
        if (status === 'SUCCESS') {
          this.menuParents = []
          let menus = resp.data.data
          for (let menu of menus) {
            if (menu.parent_id == null && menu.form_app == null) {
              this.menuParents.push(menu)
            }
          }
        }
      })
    },
    async doLoadClientId() {
      await menuServices.getClientId().then(resp => {
        let {data, message, status} = resp.data
        if (status === 'SUCCESS') {
          this.clients = data
        } else {
          this.$refs.dlgMsg.doOpenMsg(message)
        }
      }).catch(ex => {
        checkError404(ex,this.$refs.dlgMsg)
      })
    },
    async doLoadFormApp() {
      await formAppService.getAll().then(resp => {
        let {data, message, status} = resp.data
        if (status === 'SUCCESS') {
          this.form_apps = []
          let form_apps = data
          for (let form_app of form_apps) {
            let form = {
              pk: {
                id: form_app.id,
                form_type: form_app.form_type,
              },
              name: form_app.name,
            }
            this.form_apps.push(form)
          }
        } else {
          this.$refs.dlgMsg.doOpenMsg(message)
        }
      }).catch(ex => {
        checkError404(ex,this.$refs.dlgMsg)
      })
    },
    doChangeParentOnly() {
      this.setResetError()
      this.menu.parent_id = null
      this.menu.form_app = null
      this.menu.path = null
      this.menu.path_parameter = null
    },
    doChangeComponentOnly() {
      this.setResetError()
      this.menu.parent_id = null
    },
  },
}
</script>

<style scoped>

</style>